import java.io.InputStream;
import java.io.FileInputStream;
import java.io.IOException;

import org.w3c.dom.*;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

import org.apache.xerces.parsers.DOMParser;
import org.apache.xerces.dom.DocumentImpl;
import org.apache.xalan.xpath.xml.XMLParserLiaison;
import org.apache.xalan.xpath.xdom.XercesLiaison;

public class XMLIn {

	public static void main(String[] args) {
		FileInputStream lvFileIn = null;
		Document        lvDoc    = null;
		XMLOut          lvXmlOut;

		if(args.length < 1) {
			System.exit(0);
		}
		try {
			lvFileIn = new FileInputStream(args[0]);
		} catch(IOException e) {
			System.err.println(e.toString());
			System.exit(0);
		}
		try {
			lvDoc = XMLIn.parseInputStream(lvFileIn);
		} catch(IOException e) {
			System.err.println(e.toString());
			System.exit(0);
		} catch(SAXException ex) {
			System.err.println(ex.toString());
			System.exit(0);
		}


		lvXmlOut = new XMLOut(System.out);
		lvXmlOut.writeXml(lvDoc);

	} //main(String[])

    public static Document createDOMObject() {

        return new DocumentImpl();

    } //createDOMObject()

    public static Document parseInputStream(InputStream xmlInStream) throws SAXException, IOException {
        DOMParser lvParser;
        InputSource lvXmlInSource;

        lvXmlInSource = new InputSource(xmlInStream);

        lvParser = new DOMParser();

        lvParser.parse(lvXmlInSource);

        return lvParser.getDocument();


    } //parseInputStream(InputStream)

    public static XMLParserLiaison getXMLParserLiaison() {
        return new XercesLiaison();
    } //getXMLParserLiaison()

} //DOMFactory